/*

 ZDLL API MINIM

*/

#ifndef __ZA4RNG_C
#define __ZA4RNG_C 1

#ifdef __cplusplus
extern "C" {
#endif


#include "A4rng.h"
#include <windows.h>

#include "zdll.h"


static char ID[] = "ZA4rng+Minim,(L) Onix,ICQ:144312645,e-mail:azbuka@rbcmail.ru,ver:" __DATE__ " " __TIME__;


//\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\//
//\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\//
// ZDLL API                                                                   //
//\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\//
//\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\////\\//\\//

//  ,  
static 
int
_VRead(ZDLLCB* cbfunc,char *name, MINIM_STR *data)
{
  return cbfunc->ReadLocal(name, 0, 0, data);
}
//
static
int
_VWrite(ZDLLCB* cbfunc,char *name, MINIM_STR *data)
{
  return cbfunc->WriteLocal(name, 0, 0, data);
}

//
//  
// set %Z4=$zdll("ZA4rng.dll","init",key{,R,Y})
//
int __stdcall
za4c_init
 (ZDLLCB* cbfunc, MINIM_STR* result, int argc, MINIM_STR** argv)
{
  A4RNG_T e;
  WORD r=0; //   
  WORD y=0;
  MINIM_STR k;

  memset(&e,0,sizeof(e));
  memset(&k,0,sizeof(k));

  result->len=0;

  if (argc<1) return 0;

  if (argc>=1) cbfunc->GetStr(argv[0], &k);
  if (argc>=2) r = (WORD) cbfunc->GetInt32(argv[1]);
  if (argc>=3) y = (WORD) cbfunc->GetInt32(argv[2]);

// 
  A4rng_I(&e, (BYTE*)&k.data, (DWORD)k.len, r, y);

  memcpy(result->data,&e,sizeof(e));
  result->len=sizeof(e);

  return 0;
}

//
// N ,   ,   1 
// set ret=$zdll("ZA4rng.dll","rng",$na(%Z4),{,numcount})
//    ,    , ..    
//
int __stdcall
za4c_rng
 (ZDLLCB* cbfunc, MINIM_STR* result, int argc, MINIM_STR** argv)
{
  A4RNG_T *e;
  WORD n=1; //   
  MINIM_STR vn,me;

  memset(&vn,0,sizeof(vn));
  memset(&me,0,sizeof(me));

  result->len=0;

  if (argc<1) return 0;
  if (argc>=1) cbfunc->GetStr(argv[0], &vn);            //  
  if (argc>=2) n =cbfunc->GetInt32(argv[1]);    //   

  n=(n<MINIM_STR_MAX)?n:MINIM_STR_MAX;

//    
  _VRead(cbfunc,(char *)&vn.data, &me);
// ,    ,  
  if ((int)me.len != sizeof(A4RNG_T)) return -2;
//    
  e = (A4RNG_T *)&me.data;

  A4rng_S(e,(BYTE*)&result->data, n);    //  
  result->len=n;

//          
  _VWrite(cbfunc,(char *)&vn.data, &me);


  return 0;
}


//
//  IV   
// i $zdll("ZA4rng.dll","vector",$na(%Z4),strvector)
//
int __stdcall
za4c_vector
 (ZDLLCB* cbfunc, MINIM_STR* result, int argc, MINIM_STR** argv)
{
  A4RNG_T *e;
  MINIM_STR vn,iv,me;

  memset(&vn,0,sizeof(vn));
  memset(&iv,0,sizeof(iv));
  memset(&me,0,sizeof(me));

  result->len=0;

  if (argc<2) return 0;
  cbfunc->GetStr(argv[0], &vn);            //  
  cbfunc->GetStr(argv[1], &iv);            //  

//    
  _VRead(cbfunc,(char *)&vn.data, &me);
// ,    ,  
  if ((int)me.len != sizeof(A4RNG_T)) return -2;
//    
  e = (A4RNG_T *)&me.data;
// 
  A4rng_V(e,(BYTE*)&iv.data, (DWORD)iv.len);

//          
  _VWrite(cbfunc,(char *)&vn.data, &me);

  return 0;
}

//
//    
// set code=$zdll("ZA4rng.dll","ecode",$na(%Z4),str)
//
int __stdcall
za4c_ecode
 (ZDLLCB* cbfunc, MINIM_STR* result,
       int argc, MINIM_STR** argv)
{
  A4RNG_T *e;
  MINIM_STR vn,ss,me;

  memset(&vn,0,sizeof(vn));
  memset(&ss,0,sizeof(ss));
  memset(&me,0,sizeof(me));

  result->len=0;

  if (argc<2) return 0;
  cbfunc->GetStr(argv[0], &vn);            //  
  cbfunc->GetStr(argv[1], &ss);            //  

//    
  _VRead(cbfunc,(char *)&vn.data, &me);
// ,    ,  
  if ((int)me.len != sizeof(A4RNG_T)) return -2;
//    
  e = (A4RNG_T *)&me.data;

// 
  A4rng_ES(e, (BYTE*)&ss.data, (DWORD)ss.len);
// 
  memcpy(result,&ss,sizeof(MINIM_STR));

//          
  _VWrite(cbfunc,(char *)&vn.data, &me);

  return 0;
}


//
//   
// set code=$zdll("ZA4rng.dll","hash","key",str)
//
int __stdcall
za4c_hash
 (ZDLLCB* cbfunc, MINIM_STR* result,
       int argc, MINIM_STR** argv)
{
  MINIM_STR k,s;
  memset(&k,0,sizeof(k));
  memset(&s,0,sizeof(s));

  result->len=0;

  if (argc<2) return 0;

  cbfunc->GetStr(argv[0], &k);            //  
  cbfunc->GetStr(argv[1], &s);            //  

  result->len = A4rng_HS((BYTE*)&s.data, (DWORD)s.len,
                         (BYTE*)&k.data, (DWORD)k.len, (BYTE *)&result->data);
  return 0;
}


// declare array of function definitions
static ZDLLFUNC zfunctions[] =
{
  { za4c_init,  "init"  },
  { za4c_rng,   "rng"   },
  { za4c_vector,"vector"},
  { za4c_ecode, "ecode" },
  { za4c_hash,  "hash"  },

  { NULL, NULL }
};


__declspec( dllexport ) ZDLLFUNC* __stdcall
ZDLL(void)
{
  return zfunctions;
};


// DLL
#if 1

#include <windows.h>


/////////////////////////////
int WINAPI
DllEntryPoint (HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
  return 1;
}

////////////////////////////
BOOL WINAPI
DllMain (HINSTANCE hinstDLL,DWORD fdwReason, LPVOID lpvReserved)
{
 return TRUE;
}


#endif



#ifdef __cplusplus
}
#endif


#endif
