/*

   (    ),
  RC4, VMPC, 89  ... .

*/

#ifndef __A4RNG_C
#define __A4RNG_C 1

#ifdef __cplusplus
extern "C" {
#endif


#include "A4rng.h"

static char ID[] = "A4rng,(L) Onix,ICQ:144312645,e-mail:azbuka@rbcmail.ru,ver:" __DATE__ " " __TIME__;


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//                                        //
//                                                                  //
//                                                              //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//  F -                     //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

/*  RC4                                                        A4
  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  for i = 0 to n { S[ i ] = i }                               for i = 0 to n  { S[ i ] = ~i }
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
  j = 0
  for i = 0 to n
    { j = ( j + S[ i ] + Key[ i mod L ] ) 
      ( S[ i ], S[ j ] )  }
 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  i = ( i + 1 ) , j = ( j + S[ i ] ) 
  ( S[ i ], S[ j ] )
  : K = S[ ( S[ i ] + S[ j ] ) ]

VMPC ( RC4)::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c -     (16 <= c <=64)
K - 
z -      (16 <= z <=64)
V -  
m - 16- 
s - 8-  

1.  s = 0
2.  for i from 0 to 255: P[i]=i
3.  for m from 0 to 767:  . 4-6:
4.  n = m and 255
5.  s = P[ (s + P[n] + K[m mod c]) and 255 ]
6.  Temp = P[n]
    P[n] = P[s]
    P[s] = Temp
7.  for m from 0 to 767:  . 8-10:
8.  n = m and 255
9.  s = P[ (s + P[n] + V[m mod z]) and 255 ]
10. Temp = P[n]
    P[n] = P[s]
    P[s] = Temp
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
1. n = 0                                                  1.  o = F( S = P [ P[N]+P[S]+B ]
2.  . 3-6 Len :                                   swap (P[N], P[S])
3. s = P[ (s + P[n]) and 255 ]                                  return P[ ~P [ P [S] ] ]
4. Output = P[ (P[P[s]]+1) and 255 ]                          )
5. Temp = P[n]                                            2.  For i=0:1:n O ^= F ( O+K[i] )
   P[n] = P[s]                                                return P [ O ]
   P[s] = Temp
6. n = (n + 1) and 255


*/

A4RNG_EXPORT                                   //  o=T[o] , T- 
BYTE __A4rng_F(A4RNG_T *e, BYTE o) {
  e->S = e->P[M1(e->P[e->N]+e->P[e->S]+o)] ;                   //   
  o    = e->P[e->S]; e->P[e->S] = e->P[e->N]; e->P[e->N] = o;  //swap(P[N], P[S])
  e->N = M1(e->N+1);                                           //   .
  return e->P[M1(~e->P[o])];                                   //   
};


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//                                             //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT BYTE
__A4rng_A(A4RNG_T *e, BYTE b,WORD n)
{
  WORD i;
//  N ,       
  for(i=0;i<n;i++) e->O ^= __A4rng_F(e, b+e->O); 
//    
  return e->P[e->O];
}


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
// . prng                                             //
//n-                     //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT BYTE
__A4rng_B(A4RNG_T *e,WORD n)
{
  return __A4rng_A(e,0,n);
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//  16-bit,                             //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT WORD
__A4rng_W(A4RNG_T *e,WORD n)
{
  WORD w;

  w = (WORD) __A4rng_B(e,n),w*=256;        //w<<=8;
  w+= (WORD) __A4rng_B(e,n);

  return w;
}



//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//  API                                                      //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//  prng                                                //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT BYTE
A4rng_B(A4RNG_T *e)
{
  return __A4rng_B(e,e->Y);
}


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//    o[z]=b                                      //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT int
A4rng_S(A4RNG_T *e, BYTE *o, DWORD z)
{
  DWORD i;

  if (z>0)
    for(i=0; i<z;i++) o[i] = A4rng_B(e);

  return 0;
}


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//                                                    //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT int
A4rng_V(A4RNG_T *e, BYTE *v, DWORD z)
{
  DWORD i;

  if (z>0)
  {
//       A4RNG_ROTATE(e->R) ?
    for(i=0; i<z; i++)   __A4rng_A(e, v[i], e->R);
//    ,   4 
    for(i=0; i<4; i++) { __A4rng_A(e, (z%256), e->R); z/=256; }
  }

  return 0;
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//                                              //
//e-                                                  //
//k-                         //
//z-                                                      //
//r-                                              //
//y -                                             //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT void
A4rng_I(A4RNG_T *e, BYTE *k, DWORD z, WORD r, WORD y)
{
  DWORD i;
//  
  memset(e,0,sizeof(A4RNG_T));

  e->N = e->S = e->O = 0;
  e->R = (r>0)?r:A4RNG_ROTATE_R;   //       
  e->Y = (y>0)?y:A4RNG_ROTATE_Y;   //   ,    

//   ,   
  for(i=0; i<A4RNG_P_SIZE; i++) e->P[i]=M1(~i);
// ,  
  if(z>0) A4rng_V(e, k, z);
//  N . (  ,    )
  for(i=0; i<(DWORD)A4RNG_DROP_N; i++) A4rng_B(e);

}


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//base:                                             //
//                                                          //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

//    :  e->R =1
// 600Kb/c  Intel-Atom N450 1.6 GHz
void
__A4rng_H_00(A4RNG_HASH_T *e, BYTE b)
{
  WORD i;
//     
  for(i=0; i<A4RNG_HASH_SIZE; i++)
    e->H[i] ^= __A4rng_A((A4RNG_T *)&e->E, b+e->H[i], e->R);
//+1  -  
  e->L++;
}

//     e->R >= 3   1 
// : 5Mb/c  Intel-Atom N450 1.6 GHz
//    __A4rng_H
void
__A4rng_H_01(A4RNG_HASH_T *e, BYTE b)
{
  e->H[M2(e->L)] ^=  __A4rng_A((A4RNG_T *)&e->E, b + e->H[M2(e->L)], A4RNG_HASH_ROTATE_FAST);
//+1  -  
  e->L++;
}

A4RNG_EXPORT void
__A4rng_H(A4RNG_HASH_T *e, BYTE b)
{
  switch(e->T)
  {
    case 1: __A4rng_H_01(e, b); break;
    case 0:
   default: __A4rng_H_00(e, b); break;
  }
  return;
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
// ,  hash                         //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT void
A4rng_HI(A4RNG_HASH_T *e, BYTE *s, DWORD z)
{
  DWORD i;
  memset(e,0,sizeof(A4RNG_HASH_T));
  e->R=A4RNG_HASH_ROTATE;
//    
  A4rng_I((A4RNG_T *)&e->E, s, z, 0,0);
// 1   ,   H[i]
  for(i=0;i<A4RNG_HASH_ROTATE_END;i++) __A4rng_H(e,0);
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//..                                              //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT void
A4rng_HI2(A4RNG_HASH_T *e, BYTE *s, DWORD z,WORD r,BYTE t)
{
  DWORD i;
  memset(e,0,sizeof(A4RNG_HASH_T));
  A4rng_HI(e,s,z);
//  
  e->R=(r>0)?r:e->R;
  e->T=(t>0)?1:0;

}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
// ,  s  z                             //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT void
A4rng_HU(A4RNG_HASH_T *e, BYTE *s, DWORD z)
{
  DWORD i;
  for(i=0; i<z; i++) __A4rng_H(e, s[i]);
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                                  //
//  , s -    ,     //
//                                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT int
A4rng_HF(A4RNG_HASH_T *e, BYTE *s)
{
  DWORD i;
// -   (  ):
  A4rng_HU(e, (BYTE *)&e->L, sizeof(QWORD));
//       
  for(i=0;i<A4RNG_HASH_ROTATE_END;i++) __A4rng_H(e,0);
//  
  for(i=0;i<A4RNG_HASH_SIZE;i++) s[i]=e->H[i];

  return A4RNG_HASH_SIZE;
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
// , outh      A4RNG_HASH_SIZE!           //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT int
A4rng_HFile(char *f, BYTE *pwd, DWORD pwd_z, BYTE *outh)
{
  A4RNG_HASH_T e;
  FILE *finp = fopen(f,"rb");
  int err=0;
  int c;
  BYTE buff[8*1024];
  DWORD p,i;

  if(!finp) { err=-1; goto f_end; }

  A4rng_HI((A4RNG_HASH_T *)&e, pwd, pwd_z);
  while(1)
  {
     p=fread(&buff,1,sizeof(buff),finp);
     if (p==0) break;
     A4rng_HU((A4RNG_HASH_T *)&e, buff, p);
  }
  A4rng_HF((A4RNG_HASH_T *)&e, outh);

f_end:
  fclose(finp);

//  
  memset(&e,0,sizeof(A4RNG_HASH_T));

  return err;
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                             //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT int
A4rng_HS(BYTE *str, DWORD str_z, BYTE *pwd, DWORD pwd_z, BYTE *outh)
{
  A4RNG_HASH_T e;

  A4rng_HI((A4RNG_HASH_T *)&e, pwd, pwd_z);
  A4rng_HU((A4RNG_HASH_T *)&e, str, str_z);
  A4rng_HF((A4RNG_HASH_T *)&e, outh);
//  
  memset(&e,0,sizeof(A4RNG_HASH_T));

//  
  return A4RNG_HASH_SIZE;
}


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                         //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

//   
A4RNG_EXPORT int
A4rng_VS(A4RNG_T *e, char *to)
{
  FILE *f = fopen(to,"wb");
  if (!f) return -1;

  fwrite(e,1,sizeof(A4RNG_T),f);
  fclose(f);

  return 0;
}

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                            //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT int
A4rng_VL(A4RNG_T *e, char *from)
{
  FILE *f = fopen(from,"rb");
  if (!f) return -1;

  fread(e,1,sizeof(A4RNG_T),f);
  fclose(f);

  return 0;
}



//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//   api                                           //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

/// 
//        
A4RNG_EXPORT BYTE
A4rng_E(A4RNG_T *e, BYTE b)
{
  return (b ^ A4rng_B(e));
}


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                     //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT void
A4rng_ES(A4RNG_T *e, BYTE *b, DWORD z)
{
  DWORD i;
  for(i=0;i<z;i++) b[i] = A4rng_E(e,b[i]);
}


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
///                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT int
A4rng_EFile(char *from, char *to,BYTE *pwd, DWORD pwd_z)
{
  A4RNG_T e;
  FILE *finp = fopen(from,"rb");
  FILE *fout = fopen(to,"wb");
  int err=0;
  int c;
  BYTE buff[8*1024];
  DWORD p;

  if((!finp)||(!fout)) { err=-1; goto f_end; }

  memset(&e,0,sizeof(e));
  A4rng_I(&e, pwd, pwd_z, 0,0);

  while(1)
  {
     p=fread(&buff,1,sizeof(buff),finp);
     if (p==0) break;

     A4rng_ES(&e, (BYTE*)&buff,p);
     fwrite(&buff,1,p,fout);
  }

f_end:
  fclose(finp);
  fclose(fout);

  memset(&e,0,sizeof(e));

  return err;
}




// DLL
#if 0


#include <windows.h>


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
// DLL                                                              //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
int WINAPI
DllEntryPoint (HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
  return 1;
}

////////////////////////////
BOOL WINAPI
DllMain (HINSTANCE hinstDLL,DWORD fdwReason, LPVOID lpvReserved)
{
 return TRUE;
}


#endif


#ifdef __cplusplus
}
#endif


#endif
