#ifndef __A4RNG_H
#define __A4RNG_H 1

#ifdef __cplusplus
extern "C" {
#endif


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#include "zdll.h"

#ifndef A4RNG_EXPORT
#define A4RNG_EXPORT  __declspec(dllexport)
#endif

typedef unsigned char    BYTE;                // 8 
typedef unsigned short   WORD;                //16 
typedef unsigned long    DWORD;               //32
typedef unsigned __int64 QWORD;               //64


#define M1(a)     ((BYTE)(a)&0x0FF)       //   -
//#define M1(a)     ((BYTE)(a)%256)       //   -  bigingian

#define A4RNG_P_SIZE   (256)		//.   256 
//: 768  17    ,    
// (drop),      12     32 (  -WORD)
// R,Y,N -          
#define A4RNG_ROTATE_R (768)            //      
#define A4RNG_ROTATE_Y (17)        	//  ,    
#define A4RNG_DROP_N   (A4RNG_ROTATE_R*A4RNG_ROTATE_Y) 	// ,     

/*
//  :
#define A4RNG_ROTATE_R (7)              //      
#define A4RNG_ROTATE_Y (3)        	//  ,    
                                        //..  3  
                                        //  
                                        //,   
#define A4RNG_DROP_N   (13*1024) 	// ,     
*/


//   
typedef struct _A4RNG_T
{
  BYTE P[A4RNG_P_SIZE]; //  
  BYTE S,N,O; 	 	//    S,N  xor  O,  .
  WORD R,Y;   		//        R 
                        //     Y,    
} A4RNG_T;


#define A4RNG_HASH_SIZE   (32) 			    //.    
#define A4RNG_HASH_ROTATE (1)                       //      e->R
#define A4RNG_HASH_ROTATE_FAST (3)                  //  _Fast                    e->R
#define A4RNG_HASH_ROTATE_END (A4RNG_HASH_SIZE*11)  //    
#define M2(a)     ((BYTE)(a)%A4RNG_HASH_SIZE)       // ..

typedef struct _A4RNG_HASH_T
{
  QWORD   L;            	//   ..
  BYTE    H[A4RNG_HASH_SIZE];   //   
  A4RNG_T E;            	//      
  WORD R;   		        //    
  BYTE T;                       //   , 0-, 1-
} A4RNG_HASH_T;


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                        //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

A4RNG_EXPORT BYTE __A4rng_F(A4RNG_T *e, BYTE o);            //  

A4RNG_EXPORT BYTE __A4rng_B(A4RNG_T *e, WORD n);            //  
A4RNG_EXPORT WORD __A4rng_W(A4RNG_T *e, WORD n);            //16- 
A4RNG_EXPORT BYTE __A4rng_A(A4RNG_T *e, BYTE b, WORD n);    //   

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//  API                                                      //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

A4RNG_EXPORT BYTE A4rng_B(A4RNG_T *e);                      // . prng
A4RNG_EXPORT int  A4rng_S(A4RNG_T *e, BYTE *o, DWORD z);    //  
A4RNG_EXPORT int  A4rng_V(A4RNG_T *e, BYTE *v, DWORD z);    //   

//
// 
//e-  
//k-      
//z-  
//r-   
//y-   
//
A4RNG_EXPORT void A4rng_I(A4RNG_T *e, BYTE *k, DWORD z, WORD r, WORD y);

//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//: HASH+MAC                                                  //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

A4RNG_EXPORT void __A4rng_H(A4RNG_HASH_T *e, BYTE b);		    // 
A4RNG_EXPORT void A4rng_HI(A4RNG_HASH_T *e, BYTE *s, DWORD z); //, 
A4RNG_EXPORT void A4rng_HU(A4RNG_HASH_T *e, BYTE *s, DWORD z); // 
A4RNG_EXPORT int  A4rng_HF(A4RNG_HASH_T *e, BYTE *s);          //    
A4RNG_EXPORT void A4rng_HI2(A4RNG_HASH_T *e, BYTE *s, DWORD z,WORD r,BYTE t);  //  

//:     
A4RNG_EXPORT int  A4rng_HFile(char *f, BYTE *pwd, DWORD pwd_z, BYTE *outh);
A4RNG_EXPORT int  A4rng_HS(BYTE *str, DWORD str_z, BYTE *pwd, DWORD pwd_z, BYTE *outh);


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
//                                                         //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//

A4RNG_EXPORT int A4rng_VS(A4RNG_T *e, char *to);
A4RNG_EXPORT int A4rng_VL(A4RNG_T *e, char *from);


//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
// -                                              //
//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//
A4RNG_EXPORT BYTE A4rng_E(A4RNG_T *e, BYTE b);                     //
A4RNG_EXPORT void A4rng_ES(A4RNG_T *e, BYTE *b, DWORD z);          //
A4RNG_EXPORT int  A4rng_EFile(char *from, char *to, BYTE *pwd, DWORD pwd_z);    //



#ifdef __cplusplus
}
#endif


#endif
