#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>


//

//
//               sum((Y1-Y1cp)*(Y2-Y2cp))
// R(i) = ----------------------------------------;
//        sqr(sum((Y1-Y1cp)^2) * sum((Y2-Y2cp)^2))

//
//    2  (   
//
//
//

//
// ,  0...255
//
double 
Yn_cp(char *fn)
{
  __int64 sum=0,len=0;

  FILE *fr = fopen(fn,"rb");
  BYTE buff[64*1024];
  long i,p;

  while(1)
  {
    p= fread(buff,1,sizeof(buff),fr);
    if (p==0) break;
    for(i=0;i<p;i++) sum+=buff[i];
    len+=p;
  }

  fclose(fr);

  return ((double)sum/(double)len);
}

double
corr02(char *f1n, int n, double Y1cp)
{

  FILE *f1 = fopen(f1n,"rb");

  static BYTE buff1[256*256*256];
  long i,p;

  double t,sum1=0.0,sum2=0.0,sum3=0.0;

  while(1)
  {
    p= fread(buff1,1,sizeof(buff1),f1);

    if (p==0) break;

    for(i=0;i<p;i++)
    {
      if ((i+n)>=p) break;
      sum1+=((double)buff1[i]-Y1cp)*((double)buff1[i+n]-Y1cp);    //sum((Y1-Y1cp)*(Y2-Y2cp))
      sum2+=pow((double)buff1[i]-Y1cp,2);                         //sum((Y1-Y1cp)^2)
      sum3+=pow((double)buff1[i+n]-Y1cp,2);                       //sum((Y2-Y2cp)^2)
    }
  }

  t = sum1/sqrt(sum2*sum3);
  fclose(f1);

//printf("sum1=%f,sum2=%f,sum3=%f\n",sum1,sum2,sum3);

  return t;
}


int
main (int argc, char **argv)
{

  int n;
  double Y1cp;

  if(argc<2)
  {
    printf("use: testacorr file1\n");
    return -1;
  }

  Y1cp = Yn_cp(argv[1]);

  for(n=1;n<1024;n++)
  {
    printf("acorrelation=%f delta=%d file=%s\n", corr02(argv[1], n,Y1cp),n,argv[1]);
  }

  return 0;

}

