#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>

//  ,    !

//
//               sum((Y1-Y1cp)*(Y2-Y2cp))
// R(i) = ----------------------------------------;
//        sqr(sum((Y1-Y1cp)^2) * sum((Y2-Y2cp)^2))

//
//    2  (   
//
//
//

//
// ,  0...255
//
double 
Yn_cp(char *fn)
{
  __int64 sum=0,len=0;

  FILE *fr = fopen(fn,"rb");
  static BYTE buff[64*1024];
  long i,p;

  while(1)
  {
    p= fread(buff,1,sizeof(buff),fr);
    if (p==0) break;
    for(i=0;i<p;i++) sum+=buff[i];
    len+=p;
  }
  fclose(fr);

  return ((double)sum/(double)len);
}

double
corr01(char *f1n, char *f2n)
{
  double Y1cp = Yn_cp(f1n);
  double Y2cp = Yn_cp(f2n);

  FILE *f1 = fopen(f1n,"rb");
  FILE *f2 = fopen(f2n,"rb");

  long i,p;
  static BYTE buff1[256*256*256];
  static BYTE buff2[256*256*256];

  double t,sum1=0.0,sum2=0.0,sum3=0.0;
//
//               sum((Y1-Y1cp)*(Y2-Y2cp))               sum1
// R(i) = ----------------------------------------;
//        sqr(sum((Y1-Y1cp)^2) * sum((Y2-Y2cp)^2))     
//                  sum2              sum3
//printf("Y1cp=%f,Y2cp=%f\n",Y1cp,Y2cp);

  while(1)
  {
    p= fread(buff1,1,sizeof(buff1),f1);
       fread(buff2,1,sizeof(buff2),f2);

    if (p==0) break;

    for(i=0;i<p;i++)
    {
      sum1+=((double)buff1[i]-Y1cp)*((double)buff2[i]-Y2cp);    //sum((Y1-Y1cp)*(Y2-Y2cp))

//      sum2+=((double)buff1[i]-Y1cp)*((double)buff1[i]-Y1cp);  //sum((Y1-Y1cp)^2)
      sum2+=pow((double)buff1[i]-Y1cp,2);                       //sum((Y1-Y1cp)^2)

//      sum3+=((double)buff2[i]-Y2cp)*((double)buff2[i]-Y2cp);  //sum((Y2-Y2cp)^2)
      sum3+=pow((double)buff2[i]-Y2cp,2);                       //sum((Y2-Y2cp)^2)
    }
  }

  t = sum1/sqrt(sum2*sum3);
  fclose(f1);
  fclose(f2);

//printf("sum1=%f,sum2=%f,sum3=%f\n",sum1,sum2,sum3);

  return t;
}


int
main (int argc, char **argv)
{

  if(argc<3)
  {
    printf("use: testcorr file1 file2\n");
    return -1;
  }

  printf("correlation=%f  file: %s -> %s \n", corr01(argv[1], argv[2]),argv[1],argv[2]);

  return 0;

}

